<?php
// var functions
if ( ! function_exists( 'print_rr' ) ) {
	function print_rr( $content ) {
		echo '<pre>';
		print_r( $content );
		echo '</pre>';
	}
}

if ( ! function_exists( 'siget' ) ) {
	function siget( $name, $array = null ) {
		if ( ! isset( $array ) ) {
			$array = $_GET;
		}

		if ( isset( $array[ $name ] ) ) {
			return $array[ $name ];
		}

		return '';
	}
}

if ( ! function_exists( 'sipost' ) ) {
	function sipost( $name, $do_stripslashes = true ) {
		if ( isset( $_POST[ $name ] ) ) {
			return $do_stripslashes && function_exists( 'stripslashes_deep' ) ? stripslashes_deep( $_POST[ $name ] ) : $_POST[ $name ];
		}

		return '';
	}
}

if ( ! function_exists( 'siar' ) ) {
	function siar( $array, $name ) {
		if ( isset( $array[ $name ] ) ) {
			return $array[ $name ];
		}

		return '';
	}
}

if ( ! function_exists( 'siars' ) ) {
	function siars( $array, $name ) {
		$names = explode( '/', $name );
		$val   = $array;
		foreach ( $names as $current_name ) {
			$val = siar( $val, $current_name );
		}

		return $val;
	}
}

if ( ! function_exists( 'siempty' ) ) {
	function siempty( $name, $array = null ) {

		if ( is_array( $name ) ) {
			return empty( $name );
		}

		if ( ! $array ) {
			$array = $_POST;
		}

		$val = siar( $array, $name );

		return empty( $val );
	}
}

if ( ! function_exists( 'siblank' ) ) {
	function siblank( $text ) {
		return empty( $text ) && strval( $text ) != '0';
	}
}

if ( ! function_exists( 'siobj' ) ) {
	function siobj( $obj, $name ) {
		if ( isset( $obj->$name ) ) {
			return $obj->$name;
		}

		return '';
	}
}
if ( ! function_exists( 'siexplode' ) ) {
	function siexplode( $sep, $string, $count ) {
		$ary = explode( $sep, $string );
		while ( count( $ary ) < $count ) {
			$ary[] = '';
		}

		return $ary;
	}
}


if ( ! function_exists( 'getDistance' ) ) {
	function getDistance( $latitude1, $longitude1, $latitude2, $longitude2 ) {

		$earth_radius = 6371;

		$dLat = deg2rad( $latitude2 - $latitude1 );
		$dLon = deg2rad( $longitude2 - $longitude1 );

		$a = sin( $dLat / 2 ) * sin( $dLat / 2 ) + cos( deg2rad( $latitude1 ) ) * cos( deg2rad( $latitude2 ) ) * sin( $dLon / 2 ) * sin( $dLon / 2 );
		$c = 2 * asin( sqrt( $a ) );
		$d = $earth_radius * $c;

		return $d;
	}
}


function view_date( $date = "" ) {		
	if ( $date == "" ) {
		return "";
	} 
	if ( $date == "0000-00-00" ||  $date == "0000-00-00 00:00:00" ) {
		return "";
	} 		
	$date	= str_replace( "/", "-", $date );
	$date	= str_replace( ".", "-", $date );
	
	return date( "d/m/Y", strtotime( $date ) );	
}